<template>
	<div class="panel-body">
		<form @submit.prevent="validate">
			<vue-form-generator
				:schema="formSchema"
				:model="formModel"
				:options="formOptions"
				ref="form"
				@model-updated="onUpdate"
			/>
			<hr />
			
			<div class="text-center mt-3">
				<button class="btn btn-success mr-2" type="submit">
					Сохранить
				</button>
				<nuxt-link class="btn btn-danger ml-2" to="/">
					Отмена
				</nuxt-link>
			</div>
		</form>
	</div>
</template>

<script>
//Mixin с методом validationMethod() для валидации формы
import { mixinValidation } from '@/mixins/validation.mixin'

export default {
	name: 'CrudForm',
	mixins: [mixinValidation],
	props: {
		formSchema: {
			type: Object,
			default: () => {}
		},
		formModel: {
			type: Object,
			default: () => {}
		},
		formOptions: {
			type: Object,
			default: () => ({
				validateAsync: true
			})
		},
	},
	methods: {
		//Метод для соблюдения условий валидации и обращению к родительскому методу
		async validate() {
			const errors = await this.$refs.form.validate()
			const isValid = errors.length === 0
			if (isValid && this.validationMethod()) {
				this.$emit('on-submit', this.formModel)
			}
		},	
	}
}
</script>